
import atexit
import cProfile
import marshal
import os
import sys
import signal

mydir = os.path.normcase(os.path.abspath(os.path.dirname(__file__)))

sys.path = [pth for pth in sys.path
            if os.path.normcase(os.path.abspath(pth)) != mydir]

sys.path.insert(0, mydir)


def signalHandler(signum, frame):
    sys.exit(0x10000) # multiprocessing.forking.TERMINATE

signal.signal(signal.SIGBREAK, signalHandler)


statsfn = os.path.join(os.environ.get("MWTRACE_PROFILE_DIR", os.getcwd()),
                        "%s.pstats" % (os.getpid(),))

try:
    statsfile = open(statsfn, "wb")
except IOError:
    pass
else:
    profiler = cProfile.Profile()

    def dumpProfile(profiler=profiler, statsfile=statsfile,
                    _dump=marshal.dump, _fsync=os.fsync, called=[]):
        if not called:
            called.append(True)
            profiler.create_stats()
            _dump(profiler.stats, statsfile)
            statsfile.flush()
            _fsync(statsfile.fileno())
            statsfile.close()

    atexit.register(dumpProfile)

    def _setprofile(profileFunc, realFunc=profiler.enable):
        if profileFunc != realFunc:
            print >> sys.__stderr__, "unexpected profiler"
        realFunc()
    sys.setprofile = _setprofile
    import threading
    threading.setprofile(profiler.enable)
    profiler.enable()
